<?php
/*
 * Copyright (c) 2014 Optimal Payments
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
 * associated documentation files (the "Software"), to deal in the Software without restriction,
 * including without limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT
 * NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

namespace OptimalPayments\CardPayments;

/**
 * @property string $code
 * @property string $responseCode
 * @property string $avsCode
 * @property string $balanceResponse
 *
 * Desjardins (DJN)
 * @property string $batchNumber
 * @property string $effectiveDate
 * @property string $financingType
 * @property string $gracePeriod
 * @property string $plan
 * @property string $seqNumber
 * @property string $term
 * @property string $terminalId
 *
 * Credorax (CRX)
 * @property string $responseId
 * @property string $requestId
 * @property string $description
 * @property string $authCode
 * @property string $txnDateTime
 * @property string $referenceNbr
 * @property string $responseReasonCode
 * @property string $cvv2Result
 *
 * NETBANX Acquirer Gateway (NAG)
 * @property string $mid
 */
class AcquirerResponse  extends \OptimalPayments\JSONObject
{
    protected static $fieldTypes = array(
         'code' => 'string',
         'responseCode' => 'string',
         'avsCode' => 'string',
         'balanceResponse' => 'string',
         'batchNumber' => 'string',
         'effectiveDate' => 'string',
         'financingType' => 'string',
         'gracePeriod' => 'string',
         'plan' => 'string',
         'seqNumber' => 'string',
         'term' => 'string',
         'terminalId' => 'string',
         'responseId' => 'string',
         'requestId' => 'string',
         'description' => 'string',
         'authCode' => 'string',
         'txnDateTime' => 'string',
         'referenceNbr' => 'string',
         'responseReasonCode' => 'string',
         'cvv2Result' => 'string',
         'mid' => 'string',
    );

}
